> For the complete documentation index, see [llms.txt](https://docs.feast.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.feast.dev/v0.63-branch/reference/data-sources/oracle.md).

# Oracle (contrib)

## Description

Oracle data sources are Oracle database tables. These are specified by a table reference (e.g. `"TRANSACTION_FEATURES"` or `"SCHEMA.TABLE"`).

## Disclaimer

The Oracle data source does not achieve full test coverage. Please do not assume complete stability.

## Examples

Defining an Oracle source:

```python
from feast.infra.offline_stores.contrib.oracle_offline_store.oracle_source import (
    OracleSource,
)

driver_stats_source = OracleSource(
    name="driver_hourly_stats",
    table_ref="DRIVER_HOURLY_STATS",
    event_timestamp_column="EVENT_TIMESTAMP",
    created_timestamp_column="CREATED",
)
```

**Note:** Oracle stores unquoted identifiers in uppercase. Reference columns using the casing shown by Oracle (e.g. `USER_ID` for unquoted identifiers).

## Supported Types

Oracle data sources support standard Oracle numeric, string, date, and timestamp types mapped through the ibis Oracle backend. For a comparison against other batch data sources, please see [here](/v0.63-branch/reference/data-sources/overview.md#functionality-matrix).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.feast.dev/v0.63-branch/reference/data-sources/oracle.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
